<script lang="ts">
import { computed, ref } from 'vue'

export default {
  setup() {
    const gitlabIntegrationUser = ref({
      git_id: '',
      git_username: '',
      token_id: '',
      token: '',
    })

    const saving = ref(false)
    const isRequest = ref(false)
    const requestMessage = ref('')
    const passwordFieldTypeToken = ref('password')

    const passwordToggleIconToken = computed(() => {
      return passwordFieldTypeToken.value === 'password' ? 'mdi-eye' : 'mdi-eye-off'
    })

    const alertToggleVariant = computed(() => {
      return isError.value ? 'error' : 'success'
    })

    const alertToggleText = computed(() => {
      return isError.value ? 'Error!' : 'Success!'
    })

    const isError = ref(false)

    function togglePasswordToken() {
      passwordFieldTypeToken.value = passwordFieldTypeToken.value === 'password' ? 'text' : 'password'
    }

    async function addGitlabIntegrationUser() {
      console.info('INFO: updateGitlabIntegrationUser')
      saving.value = true
      isRequest.value = false

      try {
        // Simulate an API call
        console.debug('DEBUG: do something to update a gitlab user')
        requestMessage.value = 'Operation successful.'
        isError.value = false
      }
      catch (error) {
        console.debug('ERROR: updateGitlabIntegrationUser', error)
        isError.value = true
        requestMessage.value = 'Operation failed.'
      }

      saving.value = false
      isRequest.value = true
    }

    return {
      gitlabIntegrationUser,
      saving,
      isRequest,
      requestMessage,
      passwordFieldTypeToken,
      passwordToggleIconToken,
      alertToggleVariant,
      alertToggleText,
      togglePasswordToken,
      addGitlabIntegrationUser,
    }
  },
}
</script>

<template>
  <h4>AddGitlabIntegration</h4>
  <VForm
    ref="updateGitlabIntegrationUserForm"
    class="mt-2"
  >
    <VRow>
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :border-color="alertToggleVariant"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          variant="tonal"
          dense
          dismissible
        >
          <VIcon left>
            mdi-information
          </VIcon>
          <strong>{{ alertToggleText }}</strong> {{ requestMessage }}
        </VAlert>
      </VCol>
    </VRow>
    <VRow>
      <VCol cols="6">
        <VTextField
          v-model="gitlabIntegrationUser.git_id"
          label="Gitlab user id"
          :disabled="saving"
        />
      </VCol>
      <VCol cols="6">
        <VTextField
          v-model="gitlabIntegrationUser.git_username"
          label="Gitlab username"
          :disabled="saving"
        />
      </VCol>
      <VCol cols="6">
        <VTextField
          v-model="gitlabIntegrationUser.token_id"
          label="Gitlab token id"
        />
      </VCol>
      <VCol cols="6">
        <VTextField
          v-model="gitlabIntegrationUser.token"
          label="Gitlab token"
          :append-outer-icon="passwordToggleIconToken"
          :type="passwordFieldTypeToken"
          autocomplete="off"
          @click:append-outer="togglePasswordToken"
        />
      </VCol>
    </VRow>
    <VRow>
      <VCol>
        <VBtn
          color="primary"
          class="mt-2"
          :disabled="saving"
          :loading="saving"
          @click="addGitlabIntegrationUser"
        >
          Save
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>

<style scoped>
</style>
